# AUTOGENERATED! DO NOT EDIT! File to edit: nbs/01_handlers.ipynb (unless otherwise specified).

__all__ = ['AsyncFileASGIHandler']

# Cell

from asgiref.sync import sync_to_async
from django.core.handlers.asgi import ASGIHandler


class AsyncFileASGIHandler(ASGIHandler):
    """
    Same as default ASGIHandler from Django if there's no `is_async_fileresponse`
    attribute. If set to true, AsyncFileASGIHandler delegates the streaming of the
    actual response to the response to allow for statements like:
    ```python
        async with aiofiles.open(path):
            ...
    ```
    or
    ```python
        async with minio_response["Body"] as stream:
            ...
    ```
    """
    async def send_response(self, response, send):
        is_async_fileresponse = getattr(response, "is_async_fileresponse", False)
        if is_async_fileresponse:
            return await response.stream(send)
        else:
            return await super().send_response(response, send)