# AUTOGENERATED! DO NOT EDIT! File to edit: nbs/01_scripts.ipynb (unless otherwise specified).

__all__ = ['get_config', 'patch_config', 'patch_lib_name', 'nbdev_build_docs_patched']

# Cell

from pathlib import Path
from configparser import ConfigParser


def get_config(settings_path):
    config = ConfigParser()
    config.read(settings_path)
    return config


def patch_config(settings_path, lib_name):
    config = get_config(settings_path)
    config["DEFAULT"]["lib_name"] = lib_name
    with settings_path.open("w") as settings_file:
        config.write(settings_file)
    return config

# Cell

from contextlib import contextmanager


@contextmanager
def patch_lib_name(settings_path, lib_name):
    config = get_config(settings_path)
    original_lib_name = config["DEFAULT"]["lib_name"]
    config = patch_config(settings_path, lib_name)
    try:
        yield config
    finally:
        patch_config(settings_path, original_lib_name)

# Cell

import re
import sys

from nbdev.export2html import nbdev_build_docs


def nbdev_build_docs_patched():
    project_root = Path(__file__).parent.parent
    settings_path = project_root / "settings.ini"
    with patch_lib_name(settings_path, "fileresponse"):
        sys.argv[0] = re.sub(r"(-script\.pyw|\.exe)?$", "", sys.argv[0])
        sys.exit(nbdev_build_docs())